<template>
  <LoadingLogo v-if="hadVideo" :thumb="true" />
  <OpenVideo v-else @close="hadVideo = true" />
  <Guide />

  <div class="ui-view-layout" :class="{ show: show }" is-mobile="true">
    <div class="scene" ref="scene$"></div>
    <template v-if="dataLoaded">
      <Information />
      <Control />
      <teleport v-if="refMiniMap && player.showWidgets" :to="refMiniMap">
        <span class="button-switch" @click.stop="toggleMap">
          <ui-icon type="show_map_collect"></ui-icon>
        </span>

        <p class="change" @click="changeMode('dollhouse', $event, 'focus3d')">
          <ui-icon type="show_3d_normal"></ui-icon>
          3D模型
        </p>
      </teleport>
      <template v-if="refMiniMap && player.showWidgets">
        <div :class="{ disabled: flying }" v-show="mode != 'panorama'" v-if="controls.showFloorplan && controls.showDollhouse" class="tab-layer">
          <div class="tabs" v-if="controls.showMap">
            <span :class="{ active: mode === 'floorplan' }" @click="changeMode('floorplan', $event)">
              <ui-icon :type="mode == 'floorplan' ? 'show_plane_selected' : 'show_plane_normal'"></ui-icon>
              二維
            </span>
            <span :class="{ active: mode === 'dollhouse' }" @click="changeMode('dollhouse', $event)">
              <ui-icon :type="mode == 'dollhouse' ? 'show_3d_selected' : 'show_3d_normal'"></ui-icon>

              三維
            </span>
            <div class="background" ref="background"></div>
          </div>
        </div>
      </template>
    </template>
    <!-- <UiTags /> -->
  </div>

  <GoodsList @close="closetagtype" />
  <Treasure @close="closetagtype" />
  <Waterfall @close="closetagtype" />
</template>

<script setup>
import { useMusicPlayer } from "@/utils/sound";
// import UiTags from "@/components/Tags";
import GoodsList from "@/components/Tags/goods-list.vue";
import Treasure from "@/components/Tags/treasure.vue";
import Waterfall from "@/components/Tags/waterfall.vue";

import Information from "@/components/Information";
import Control from "@/components/Controls/Control.Mobile.vue";
import LoadingLogo from "@/components/shared/Loading.vue";
import OpenVideo from "@/components/openVideo/";
import Guide from "@/components/shared/Guide.vue";

import { createApp } from "@/app";
import { ref, onMounted, computed, nextTick, watch } from "vue";
import { useStore } from "vuex";
import browser from "@/utils/browser";
import { useApp, getApp } from "@/app";
import common from "@/utils/common";
import { Cache } from "@/utils/index";

import * as apis from "@/apis/index.js";

let jumpNewScene = (sceneFirstView) => {
  let url = window.location.href;

  if (!browser.hasURLParam("pose")) {
    url += `&${sceneFirstView.sceneview}`;
  } else {
    url = browser.replaceQueryString(url, "pose", sceneFirstView.sceneview.replace("pose=", ""));
  }

  url = browser.replaceQueryString(url, "m", sceneFirstView.num);
  return url;
};

let visibilitychangeFn = () => {
  if (browser.isTabHidden()) {
    apis.burying_point({ type: 1 });
  }
};

let hashchangefn = () => {
  if (window.location.hash.indexOf("#showpage") >= 0) {
    window.history.go(-1);
  }
};

const musicPlayer = useMusicPlayer();

let app = null;

let tagid = browser.getURLParam("tagid");

const closetagtype = () => {
  store.commit("tag/setTagClickType", {
    type: "",
    data: {},
  });
};

const store = useStore();
const tags = computed(() => {
  return store.getters["tag/tags"] || [];
});
const player = computed(() => store.getters["player"]);
const flying = computed(() => store.getters["flying"]);
const metadata = computed(() => store.getters["scene/metadata"]);
const controls = computed(() => {
  return metadata.value.controls;
});
const mode = computed(() => store.getters["mode"]);
const showNavigations = computed(() => store.getters["showNavigations"]);
const scene$ = ref(null);
const hadVideo = ref(true);

if (!Cache.get("HIDENVIDEOEXPIRES")) {
  if (browser.getURLParam("m") == "eur-KJ-z5ZEV22AeU" && browser.getURLParam("pose") == "pano:408,qua:-0.006,0.6299,0.0049,0.7766") {
    Cache.set("HIDENVIDEOEXPIRES", "yes", 60 * 8 * 60);
    hadVideo.value = false;
  } else {
    hadVideo.value = true;
  }
}

const show = ref(false);
const dataLoaded = ref(false);
const refMiniMap = ref(null);
const isCollapse = ref(false);
const background = ref(null);
const resize = () => {
  if (this.$refs.background && (this.mode == "floorplan" || this.mode == "dollhouse")) {
    this.$nextTick(() => {
      let $active = $(this.$el).find(".tabs .active");
      background.value.style.width = $active[0].getBoundingClientRect().width + "px";
      background.value.style.left = $active.position().left + "px";
    });
  }
};

// watch(
//   () => hadVideo.value,
//   (val, old) => {
//     if (val) {
//       app.Scene.unlock();
//     }
//   }
// );

watch(
  () => player.value.showMap,
  (val, old) => {
    if (!isCollapse.value) {
      let $minmap = document.querySelector("[xui_min_map]");
      if ($minmap) {
        if (val) {
          $minmap.classList.remove("collapse");
        } else {
          $minmap.classList.add("collapse");
        }
      }
    }
  },
  {
    deep: true,
  }
);
watch(
  () => player.value.showWidgets,
  (val, old) => {
    let $minmap = document.querySelector("[xui_min_map]");
    if ($minmap) {
      if (val) {
        $minmap.classList.remove("collapse");
      } else {
        $minmap.classList.add("collapse");
      }
    }
  },
  {
    deep: true,
  }
);
const changeMode = (name, e, focus3d = false) => {
  if (!flying.value) {
    let width, left;
    store.commit("setMode", name);
    nextTick(() => {
      if (focus3d) {
        let $active = document.querySelector(".tabs>span:last-of-type");
        background.value.style.width = $active.getBoundingClientRect().width + "px";
        background.value.style.left = $active.offsetLeft + "px";
      } else {
        background.value.style.width = width || e.srcElement.getBoundingClientRect().width + "px";
        background.value.style.left = left || e.srcElement.offsetLeft + "px";
      }
    });
  }
  // console.dir(document.querySelector(".tabs>span:last-of-type"));
};
const toggleMap = () => {
  isCollapse.value = !isCollapse.value;
  let $minmap = document.querySelector("[xui_min_map]");
  if ($minmap) {
    if (!isCollapse.value) {
      $minmap.classList.remove("collapse");
    } else {
      $minmap.classList.add("collapse");
    }
  }
};

const onClickTagInfo = (el) => {
  el.stopPropagation();
  let item = tags.value.find((item) => item.sid == el.target.dataset.id);
  if (item.type == "commodity") {
    store.commit("tag/setTagClickType", {
      type: "goodlist",
      data: item,
    });
  } else if (item.type == "link_scene") {
    let sceneFirstView = item.hotContent.sceneFirstView;
    window.location.href = jumpNewScene(sceneFirstView);
  }
};

onMounted(async () => {
  apis.burying_point({ type: 0 });

  app = createApp({
    num: browser.getURLParam("m"),
    dom: scene$.value,
    mobile: true,
    isLoadTags: false,
    scene: {
      markerOpacity: 1,
      markerURL: "https://eurs3.4dkankan.com/cdf/file/43aa29799bfd472298a47cc6370b10cc.png",
      pathEndColor: "#FF4641",
    },
  });
  app.use("MinMap", { theme: { camera_fillStyle: "#ED5D18" } });
  app.use("Tag");
  app
    .use("TagView", {
      render(data) {
        if (data.type == "waterfall") {
          return `<span class="tag-icon waterfall animate" style="background-image:url({{icon}})"></span>`;
        } else if (data.type == "coupon") {
          return `<span class="tag-icon coupon animate" style="background-image:url({{icon}})"></span>`;
        } else if (data.type == "applet_link") {
          try {
            data.hotContent = JSON.parse(data.hotContent);
          } catch (error) {}
          return `<span class="tag-icon applet_link animate" style="background-image:url(${
            data.hotContent.liveIcon.src ? common.changeUrl(data.hotContent.liveIcon.src) : "{{icon}}"
          })"></span>`;
        } else if (data.type == "link_scene") {
          return `<span class="tag-icon animate" style="background-image:url({{icon}})"></span>
                      <div class="tag-body">
                        <div data-id="${data.sid}" class="tag-commodity tag-link_scene">
                          <p class="tag-title">點擊前往下一個區域</p>
                        </div>
                      </div>
                  `;
        } else if (data.type == "commodity") {
          let arr = data.products.map((item) => item.price);
          let priceMin = isFinite(Math.min.apply(null, arr)) ? Math.min.apply(null, arr) : 0;
          let priceMax = isFinite(Math.max.apply(null, arr)) ? Math.max.apply(null, arr) : 0;
          let price = priceMin == priceMax ? priceMax : `${priceMin}-${priceMax}`;
          let range = `${data.products[0] ? data.products[0].symbol : "MOP$"} ${price}`;
          return `<span class="tag-icon animate" style="background-image:url({{icon}})"></span>
                      <div class="tag-body">
                        <div data-id="${data.sid}" class="tag-commodity">
                          <div  style="background-image:url(${data.products[0] ? data.products[0].pic : ""})" class='tag-avatar'>
                          </div>
                          <p class="tag-title">${data.title}</p>
                          <p class="tag-info">${range} | 查看 ></p>
                        </div>
                      </div>
                  `;
        } else {
          return `<span class="tag-icon animate" style="background-image:url({{icon}})"></span>`;
        }
      },
    })
    .then((view) => {
      view.on("click", (e) => {
        var tag = e.data;
        // 聚焦當前點擊的熱點
        view.focus(tag.sid).then(() => {
          if (tag.type == "coupon") {
            try {
              let hotcontent = JSON.parse(tag.hotContent);
              browser.openLink(
                "/subPackage/pages/activity/activity?pageId=" + hotcontent.couponLink,
                `https://m.cdfmembers.com/shop/600667208/showactivity?pageId=${hotcontent.couponLink}`,
                `/pages/showactivity/showactivity?pageId=${hotcontent.couponLink}`
              );
              apis.burying_point({ type: 2 });
            } catch (error) {}
          } else if (tag.type == "waterfall") {
            store.commit("tag/setTagClickType", {
              type: "waterfall",
              data: tag,
            });
          } else if (tag.type == "applet_link") {
            browser.openLink(tag.hotContent.liveLink);
          } else if (tag.type == "link_scene") {
            let sceneFirstView = tag.hotContent.sceneFirstView;
            window.location.href = jumpNewScene(sceneFirstView);
          }
        });
      });

      view.on("focus", (e) => {
        document.querySelectorAll("[xui_tags_view] >div").forEach((el) => {
          if (el.getAttribute("data-tag-type") == "link_scene" || el.getAttribute("data-tag-type") == "commodity") {
            el.querySelector(".tag-body").classList.remove("show");
            el.style.zIndex = "auto";
          }
        });
        if (e.data.type == "commodity" || e.data.type == "link_scene") {
          e.target.style.zIndex = "999";
          e.target.querySelector(".tag-body").classList.add("show");
          e.target.querySelector(".tag-commodity").removeEventListener("click", onClickTagInfo);
          e.target.querySelector(".tag-commodity").addEventListener("click", onClickTagInfo);

          if (tagid) {
            document.querySelector(`[data-id="${tagid}"]`) && document.querySelector(`[data-id="${tagid}"]`).click();
            tagid = null;
          }
        }
      });

      view.on("rendered", (e) => {
        tagid && view.focus(tagid);
      }); //dom渲染完成
    });

  app.use("TourPlayer");
  // if (!hadVideo.value) {
  //   app.Scene.lock();
  // }
  app.Scene.on("ready", () => {
    show.value = true;
  });
  app.Scene.on("loaded", (pano) => {
    refMiniMap.value = "[xui_min_map]";
    store.commit("setFloorId", pano.floorIndex);
    app.resource.tags(`${process.env.VUE_APP_RESOURCE_URL}cdf/hot/${browser.getURLParam("m")}/hot.json?rnd=${Math.random()}`);
    useMusicPlayer();
  });
  app.Scene.on("panorama.videorenderer.resumerender", () => {
    musicPlayer.pause(true);
  });

  app.Scene.on("panorama.videorenderer.suspendrender", async () => {
    let player = await getApp().TourManager.player;
    if (!player.isPlaying) {
      musicPlayer.resume();
    }
  });
  app.store.on("metadata", (metadata) => {
    store.commit("scene/load", metadata);
    if (!metadata.controls.showMap) {
      app.MinMap.hide(true);
    }
    dataLoaded.value = true;
  });
  app.store.on("tags", (tags) => {
    store.commit("tag/load", tags);
  });
  app.Camera.on("mode.beforeChange", ({ fromMode, toMode, floorIndex }) => {
    if (fromMode) {
      store.commit("setFlying", true);
    }
  });
  app.Camera.on("mode.afterChange", ({ toMode, floorIndex }) => {
    store.commit("setFlying", false);
  });
  app.Camera.on("flying.started", (pano) => {
    store.commit("setFlying", true);
  });
  app.Camera.on("flying.ended", ({ targetPano }) => {
    store.commit("setFlying", false);
    store.commit("setPanoId", targetPano.id);
    if (app.Scene.isCurrentPanoHasVideo) {
      apis.burying_point({ type: 5 });
    }
  });

  app.Camera.on("pano.chosen", (pano) => {
    apis.burying_point({ type: 4 });
  });
  app.store.on("tour", async (tour) => {
    app.TourManager.load(tour);
    store.commit("tour/setData", {
      tours: JSON.parse(
        JSON.stringify(app.TourManager.tours, (key, val) => {
          if (key === "audio") {
            return null;
          } else {
            return val;
          }
        })
      ),
    });
    store.commit("tour/setBackUp", {
      tours: JSON.parse(
        JSON.stringify(app.TourManager.tours, (key, val) => {
          if (key === "audio") {
            return null;
          } else {
            return val;
          }
        })
      ),
    });
  });
  app.store.on("floorcad", (floor) => store.commit("scene/loadFloorData", floor));

  app.render();
  document.removeEventListener("visibilitychange", visibilitychangeFn);
  document.addEventListener("visibilitychange", visibilitychangeFn);

  if (browser.detectWeixin()) {
    //ios的ua中无miniProgram，但都有MicroMessenger（表示是微信浏览器）
    wx.miniProgram.getEnv((res) => {
      if (res.miniprogram) {
        window.removeEventListener("hashchange", hashchangefn);
        window.addEventListener("hashchange", hashchangefn);
      }
    });
  }
});
</script>
<style lang="scss">
.tab-layer {
  width: 100%;
  text-align: center;
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 10;
  position: fixed;
  left: 50%;
  transform: translateX(-50%);
  top: 2.3rem;
  pointer-events: none;
}
.tabs {
  pointer-events: auto;
  position: relative;
  display: flex;
  background: #222222;
  border-radius: 6px;
  padding: 2px;
  justify-content: center;
  align-items: center;
  border: 1px solid rgba(255, 255, 255, 0.1);
  box-shadow: inset 0px 0px 6px 0px rgba(0, 0, 0, 0.5);
  .background {
    position: absolute;
    left: 2px;
    top: 2px;
    bottom: 2px;
    width: 50%;
    border-radius: 4px;
    background: #444444;
    box-shadow: 2px 0px 4px 0px rgba(0, 0, 0, 0.3);
    z-index: 0;
    transition: left 0.3s;
  }
  span {
    flex: 1;
    color: #fff;
    opacity: 0.5;
    border-radius: 6px;
    height: 0.94737rem;
    font-size: 0.36842rem;
    transition: all 0.3s ease;
    display: flex;
    align-items: center;
    justify-content: center;
    padding-left: 10px;
    padding-right: 10px;
    white-space: nowrap;
    z-index: 1;
    i {
      font-size: 0.47368rem;
      margin-right: 4px;
      pointer-events: none;
    }
  }

  span.active {
    opacity: 1;
  }
}

[xui_tags_view] {
  .tag-body {
    /* display: none; */
    position: absolute;
    left: 50%;
    bottom: 50px;
    transform: translateX(-50%) scale(0);
    transform-origin: bottom;
    transition: all 0.3s cubic-bezier(0.35, 0.32, 0.65, 0.63);
    // pointer-events: none;
    .tag-commodity,
    .tag-link_scene {
      min-width: 230px;
      height: 76px;
      background: rgba(255, 255, 255, 0.8);
      box-shadow: 0px 3px 6px 0px rgba(0, 0, 0, 0.16);
      border-radius: 2px;
      position: relative;
      margin-bottom: 30px;
      &::before {
        content: "";
        display: inline-block;
        left: 50%;
        transform: translateX(-50%);
        width: 2px;
        height: 28px;
        bottom: -30px;
        background: linear-gradient(145deg, rgba(255, 255, 255, 0.8), rgba(255, 255, 255, 0));
        position: absolute;
      }
      .tag-avatar {
        position: absolute;
        z-index: 99;
        width: 80px;
        height: 80px;
        background: #ffffff;
        box-shadow: 0px 3px 6px 0px rgb(0 0 0 / 16%);
        border-radius: 2px;
        top: -14px;
        left: -12px;
        background-size: cover;
        pointer-events: none;
      }
      > p {
        color: #131d34;
        font-size: 16px;
        pointer-events: none;
      }
      .tag-title {
        padding: 10px 10px 10px 76px;
        overflow: hidden;
        text-overflow: ellipsis;
        white-space: nowrap;
        width: 240px;
      }
      .tag-info {
        padding: 0 20px 0 76px;
        font-size: 12px;
        overflow: hidden;
        text-overflow: ellipsis;
        white-space: nowrap;
      }
    }
    &.show {
      transform: translateX(-50%) scale(1);
    }

    .tag-link_scene {
      height: auto;
      min-width: unset;
      .tag-title {
        padding: 10px;
        width: auto;
        text-align: center;
      }
    }
  }

  .coupon {
    width: 84px !important;
    height: 84px !important;
    &::after {
      content: "發現好禮";
      width: 100%;
      color: #ed5d18;
      position: absolute;
      bottom: -24px;
      text-align: center;
      font-size: 14px;
    }
  }

  .waterfall {
    width: 90px !important;
    height: 90px !important;
  }

  .applet_link {
    width: 64px !important;
    height: 64px !important;
    border-radius: 50%;
    background-color: #fff;
    border: 1px solid #ed5d18;
    position: relative;
    overflow: hidden;
    &::after {
      content: "直播中";
      width: 100%;
      height: 20px;
      background: #ed5d18;
      position: absolute;
      bottom: 0;
      text-align: center;
      line-height: 1.2;
      font-size: 12px;
      border-radius: 26%;
    }
  }
}

@media (orientation: landscape) {
  .tab-layer {
    top: 1.2rem;
    .tabs {
      height: 0.7rem;
      > span {
        height: 0.7rem;
        font-size: 0.25rem;
      }
    }
  }
}
</style>
